#include <stdio.h>
#define n1  4096
#define n2  4032
#define f48 348         // max join_do_flat file is 348
char  head[72][80], f1[30],f2[30];
float a[n2][n1/2],ccd[n1*f48],fm[f48], gg,rr,ss;
FILE  *fp,*f[f48];		
int   imode,ip=0;
float sky;

main(ac,av)
int ac; char *av[];                        
{
  int i,j,k;			 
  float x1,x2,x3,x4;
  if(ac<3){
    printf("\n\t**** superflat batch_file name\n");
    printf("\n\tUsage: b3f4 1.1 sky\n\n");   
    exit(0);
  }
  strcpy(f1,av[1]);		/* batch file */
  sscanf(av[2],"%f",&sky);
  fp=fopen(f1,"r");
  if(fp==0){ printf("\n\tbatch_file not found: %s\n",f1); exit(0); }
  i=0;
l10:
  fgets(f1,30,fp); if(feof(fp))goto l20;
  if(f1[0]=='#')goto l10; 
  f1[strlen(f1)-1]=0;
  if(f1[0]!='q'){ printf("\n\tfile must be q*_?.fit\n\n"); exit(0); }
  f[i]=fopen(f1,"rb"); if(f[i]==0){ printf("not found!\n"); exit(0); }
  fread(head,80,72,f[i]);
  sscanf(&head[3][24],"%d",&j);
  sscanf(&head[4][24],"%d",&k);
  if(j!=n1 || k!=n2){ printf("not a 4096*4032 file\n"); exit(0); }
  k=indexpos(head,"SKYADU  ",72);
  sscanf(&head[k][20],"%f",&fm[i]); 
  if(fm[i]>sky){ fclose(f[i]); goto l10; }     // 2015,02,11
  if(fm[i]<150){ fclose(f[i]); goto l10; }
  printf("%4d:  %s  %9.2f\n",i+1,f1,fm[i]);
  i++;
  if(i<f48)goto l10;
l20:
  fclose(fp); ip=i;
  if(ip < 9)stop("too less files\0");
  printf("Median    ");
//  gg=3.9; rr=12.;
  ss=3.;
  k=indexpos(head,"GAIN    ",72);
  sscanf(&head[k][10],"%f %f %f %f",&x1,&x2,&x3,&x4); gg=(x1+x2+x3+x4)/4.;
  k=indexpos(head,"RDNOISE ",72);
  sscanf(&head[k][10],"%f %f %f %f",&x1,&x2,&x3,&x4); rr=(x1+x2+x3+x4)/4.;
  imode=1; 
  work(a);
  strncpy(&head[1][27],"-32",3);	/* real*4 */
  strncpy(&head[3][26],"2048",4);
  k=indexpos(head,"SKYADU  ",72);
  gg=0.; for(i=0;i<ip;i++)gg+=fm[i];  
  sprintf(&head[k][9]," %20.2f ",gg); head[k++][31]='/';
  sprintf(&head[k][0],"SUP_FLAT=  %4d %7.1f",ip,sky); head[k][23]=32; 
  strcpy(f2,f1);  f2[0]='g'; sprintf(&f2[6],"_?.fit",f1); f2[7]=f1[11];
  printf("produce: %s\n",f2);
  fp=fopen(f2,"wb");
  fwrite(head,80,72,fp);
  swap4(a,n1*n2*2);
  fwrite(a,2,n1*n2,fp);
  fclose(fp);
}

work()
{
  float bb[f48],w[f48];
  float c0,c1,x;
  int i,j,k,l;
  printf("gain= %6.2f   readnoise= %6.2f  nsigma= %6.2f\n",gg,rr,ss);
  for(i=0;i<58;i++)printf("-"); printf("\n");
/*          c0=ss*r/g      c1=ss/sqrt(gW)           */
  c1=0; for(i=0;i<ip;i++)c1+=fm[i]; c1/=ip;
  c0 = ss*rr/gg;
  c1 = ss/sqrt(gg*c1);
  for(i=0;i<n2;i++){
    if(i%99==0){ printf("."); fflush(stdout); }
    for(j=0;j<ip;j++){ k=j*n1; fread(&ccd[k],4,n1,f[j]); }
    swap4(ccd,n1*ip*4);		
    for(j=0;j<n1/2;j++){
      l=j; for(k=0;k<ip;k++){ w[k]=fm[k]; bb[k]=ccd[l]/fm[k]; l+=n1; }
//      if(imode == 0)sup_mean(bb,ip,w,c0,c1,&x);
      if(imode == 1)sup_median(bb,ip,&x);
      if(x < 0.001)x=0.001;
      a[i][j] =x;
    }
  }
  for(j=0;j<ip;j++)fclose(f[j]); 
}
	
sup_mean(a,nn,w,c0,c1,mean)
float a[],w[],c0,c1,*mean; 
int nn;
{
  int i,j,m;
  float x,xx;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if(a[i]>a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
    x=w[i]; w[i]=w[j]; w[j]=x;
  }
  j=nn;
l10:
  m=j; i=j/2;
  x= (i+i==j) ? (a[i]+a[i-1])*.5 : a[i];
/*   sigma = ((r/g)**2 + <I>/g)** (1/2) */
/*  I[j] - <I> > 3*sigma                 ignore
               > ss*sqrt((r/g)**2+<I>/g)
    I[j] == x[j]*w[j]        w[j] is normalize value, is mean counting 
 so. x[j]w[j] - <xw> > ss*sqrt( 4 + <xw>/g)
                             4 is too small, w use mean value of all w
     x[j]W - <x>W > ss*sqrt(<x>W/g)
     x[j] - <x> > ss/sqrt(gW) * sqrt(<x>)
                > rgs * sqrt(<x>)
   if(<x> < 0) use ss*sqrt((r/g)**2) == ss*r/g
          c0=ss*r/g      c1=ss/sqrt(gW)
*/
  xx = ( x<0.) ? c0 : c1*sqrt(x);
  j=0;
  for(i=0;i<m;i++){
    a[j]=a[i];
    w[j++]=w[i];
    if((a[i]-x) > xx)j--;
  }
  if(m!=j && j>2)goto l10;
/* consider weight  */
  x=xx=0.;
  for(i=0;i<m;i++){ xx+=w[i]; x+=a[i]*w[i]; }
  *mean= x/xx;
}
	
sup_median(a,nn,medi)
float *a,*medi; int nn;
{
  float x; int i,j;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if( *(a+i) > *(a+j)){
    x= *(a+i); *(a+i) = *(a+j); *(a+j)=x;
  }
  i=nn/2;
  *medi = (i+i==nn) ? (*(a+i) + *(a+i-1))*0.5 : *(a+i);
}
